//---------------------------------------------------------------------------
#ifndef _MainH_
        #define _MainH_
//---------------------------------------------------------------------------
        #include <Classes.hpp>
        #include <Controls.hpp>
        #include <StdCtrls.hpp>
        #include <Forms.hpp>
        #include <ComCtrls.hpp>
        #include <ExtCtrls.hpp>
        #include <Grids.hpp>
        #include <Menus.hpp>
        #include <ValEdit.hpp>
        #include <Chart.hpp>
        #include <Series.hpp>
        #include <TeEngine.hpp>
        #include <TeeProcs.hpp>
        #include "CSPIN.h"
        #include <Dialogs.hpp>
//---------------------------------------------------------------------------
        #define con_DIAP_Z_Steps        500
        #define con_X_Step_Delta_um     4000
//---------------------------------------------------------------------------
        class TForm_Main : public TForm {
                __published:
                        TPanel *Panel_Connect;
                        TLabel *Label_Connect_NetAddress;
                        TLabel *Label_Connect_Baud;
                        TButton *Button_Connect;
                        TComboBox *ComboBox_Connect_NetAddress;
                        TComboBox *ComboBox_Connect_Baud;
                        TPanel *Panel_Ranges;
                        TLabel *Label_Ranges_Model_Capture;
                        TLabel *Label_Ranges_Model_Value;
                        TLabel *Label_Ranges_Serial_Capture;
                        TLabel *Label_Ranges_Serial_Value;
                        TLabel *Label_Ranges_Base_Capture;
                        TLabel *Label_Ranges_Base_Value;
                        TLabel *Label_Ranges_RangeZ_Value;
                        TLabel *Label_Ranges_RangeZ_Capture;
                        TLabel *Label_Ranges_RangeXs_Capure;
                        TLabel *Label_Ranges_RangeXs_Value;
                        TLabel *Label_Ranges_RangeXe_Capure;
                        TLabel *Label_Ranges_RangeXe_Value;
                        TPanel *Panel_Parameters;
                        TPageControl *PageControl_Parameters;
                        TTabSheet *TabSheet_User_Parameters;
                        TValueListEditor *ValueListEditor_User_Parameters;
                        TTabSheet *TabSheet_Factory_Parameters;
                        TValueListEditor *ValueListEditor_Factory_Parameters;
                        TPopupMenu *PopupMenu_User_Parameters;
                        TMenuItem *Read_User_Parameter;
                        TMenuItem *Load_User_Parameter;
                        TMenuItem *Separator_User_Parameters_0;
                        TMenuItem *Read_User_Parameters;
                        TMenuItem *Load_User_Parameters;
                        TMenuItem *Separator_User_Parameters_1;
                        TMenuItem *Write_User_Parameters;
                        TMenuItem *Restore_User_Parameters;
                        TPopupMenu *PopupMenu_Factory_Parameters;
                        TMenuItem *Load_Factory_Parameters;
                        TMenuItem *Separator_Factory_Parameters_0;
                        TMenuItem *Write_Factory_Parameters;
                        TMenuItem *Reastore_Factory_Parameters;
                        TMenuItem *Read_Factory_Parameters;
                        TPageControl *PageControl_Interface;
                        TTabSheet *TabSheet_Result;
                        TChart *Chart_Result_Oscilloscope;
                        TTabSheet *TabSheet_Video;
                        TTabSheet *TabSheet_Calibration;
                        TTimer *Timer_Resize;
                        TButton *Button_Get_Result;
                        TPointSeries *Series_Result_Oscilloscope;
                        TTimer *Timer_Result;
                        TButton *Button_Get_Video;
                        TPaintBox *PaintBox_BitMap;
                        TTimer *Timer_Repaint;
                        TPanel *Panel_Motor;
                        TButton *Button_Motor_Connect;
                        TCSpinEdit *SpinEdit_Motor_Move_Steps;
                        TButton *Button_Motor_Forward;
                        TButton *Button_Motor_Backward;
                        TButton *Button_Motor_Init;
        TTimer *Timer_Motor;
        TButton *Button_Calibration;
        TCSpinEdit *SpinEdit_Motor_Move_Start;
        TChart *Chart_Calibr_Oscilloscope;
        TPointSeries *Series_Calibr_Oscilloscope;
        TLabel *Label_Motor_Start;
        TLabel *Label1;
        TButton *Button_Calibr_Save_File;
        TButton *Button_Calibr_Load_File;
        TOpenDialog *OpenDialogData;
        TSaveDialog *SaveDialogData;
        TButton *Button_TABLE_Trans;
        TButton *Button_TABLE_Save;
        TMenuItem *Separator_User_Parameters_2;
        TMenuItem *Rotate_System;
        TMenuItem *Write_Angle;
        TMenuItem *Restore_Angle;
        TPanel *Panel_Angle_Freq;
        TTimer *Timer_Errors;
        TLabel *Panel_Angle;
        TLabel *Panel_Freq;
        TTimer *Timer_Video;
        TCSpinEdit *CSpinEdit_Calibr_Ind_Step;
        TButton *Button_Calibr_Calculate;
        TCSpinEdit *CSpinEdit_Calibr_Ind_Data;
        TButton *Button_Calibr_Rst_Pnt;
        TLabel *Label2;
        TLabel *Label3;
        TPopupMenu *PopupMenu_Save_Data;
        TMenuItem *MenuItem4;
        TMenuItem *MenuItem5;
        TPointSeries *Series_Calibr_Oscilloscope1;
        TEdit *Edit_X_Left;
        TEdit *Edit_X_Right;
        TEdit *Edit_ZERO_Left;
        TEdit *Edit_ZERO_Right;
        TMenuItem *N1;
        TMenuItem *Collect1;
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall Button_ConnectClick(TObject *Sender);
        void __fastcall ValueListEditor_User_ParametersContextPopup(
          TObject *Sender, TPoint &MousePos, bool &Handled);
        void __fastcall ValueListEditor_User_ParametersEditButtonClick(
          TObject *Sender);
        void __fastcall ValueListEditor_User_ParametersExit(
          TObject *Sender);
        void __fastcall ValueListEditor_User_ParametersKeyPress(
          TObject *Sender, char &Key);
        void __fastcall ValueListEditor_User_ParametersSelectCell(
          TObject *Sender, int ACol, int ARow, bool &CanSelect);
        void __fastcall ValueListEditor_Factory_ParametersContextPopup(
          TObject *Sender, TPoint &MousePos, bool &Handled);
        void __fastcall ValueListEditor_Factory_ParametersEditButtonClick(
          TObject *Sender);
        void __fastcall ValueListEditor_Factory_ParametersKeyPress(
          TObject *Sender, char &Key);
        void __fastcall ValueListEditor_Factory_ParametersSelectCell(
          TObject *Sender, int ACol, int ARow, bool &CanSelect);
        void __fastcall ValueListEditor_Factory_ParametersExit(
          TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall Read_User_ParameterClick(TObject *Sender);
        void __fastcall Load_User_ParameterClick(TObject *Sender);
        void __fastcall Read_User_ParametersClick(TObject *Sender);
        void __fastcall Load_User_ParametersClick(TObject *Sender);
        void __fastcall Write_User_ParametersClick(TObject *Sender);
        void __fastcall Restore_User_ParametersClick(TObject *Sender);
        void __fastcall Read_Factory_ParametersClick(TObject *Sender);
        void __fastcall Load_Factory_ParametersClick(TObject *Sender);
        void __fastcall Write_Factory_ParametersClick(TObject *Sender);
        void __fastcall Reastore_Factory_ParametersClick(TObject *Sender);
        void __fastcall FormResize(TObject *Sender);
        void __fastcall Timer_ResizeTimer(TObject *Sender);
        void __fastcall Button_Get_ResultClick(TObject *Sender);
        void __fastcall Timer_ResultTimer(TObject *Sender);
        void __fastcall Button_Get_VideoClick(TObject *Sender);
        void __fastcall Timer_RepaintTimer(TObject *Sender);
        void __fastcall Button_Motor_ConnectClick(TObject *Sender);
        void __fastcall Button_Motor_InitClick(TObject *Sender);
        void __fastcall Button_Motor_ForwardClick(TObject *Sender);
        void __fastcall Timer_MotorTimer(TObject *Sender);
        void __fastcall Button_Motor_BackwardClick(TObject *Sender);
        void __fastcall Button_CalibrationClick(TObject *Sender);
        void __fastcall TabSheet_ResultShow(TObject *Sender);
        void __fastcall TabSheet_VideoShow(TObject *Sender);
        void __fastcall TabSheet_CalibrationShow(TObject *Sender);
        void __fastcall Button_Calibr_Save_FileClick(TObject *Sender);
        void __fastcall Button_Calibr_Load_FileClick(TObject *Sender);
        void __fastcall Button_TABLE_TransClick(TObject *Sender);
        void __fastcall Button_TABLE_SaveClick(TObject *Sender);
        void __fastcall Rotate_SystemClick(TObject *Sender);
        void __fastcall Write_AngleClick(TObject *Sender);
        void __fastcall Restore_AngleClick(TObject *Sender);
        void __fastcall Timer_ErrorsTimer(TObject *Sender);
        void __fastcall PaintBox_BitMapMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall PaintBox_BitMapMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall PaintBox_BitMapMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall Timer_VideoTimer(TObject *Sender);
        void __fastcall Button_Calibr_CalculateClick(TObject *Sender);
        void __fastcall CSpinEdit_Calibr_Ind_StepChange(TObject *Sender);
        void __fastcall Button_Calibr_Rst_PntClick(TObject *Sender);
        void __fastcall MenuItem4Click(TObject *Sender);
        void __fastcall MenuItem5Click(TObject *Sender);
                private:
                public:
                        WORD Min_Height;
                        __fastcall TForm_Main(TComponent* Owner);
                        void __fastcall View_User_Parameters();
                        void __fastcall View_Factory_Parameters();
                        void __fastcall Update_User_Parameters();
                        void __fastcall Update_Factory_Parameters();
                        void __fastcall Convert_Line_Pixel();
                        void __fastcall Convert_Pixel_Z();
                        void __fastcall Convert_Pixel_X();                        
};
//---------------------------------------------------------------------------
        extern PACKAGE TForm_Main *Form_Main;
//---------------------------------------------------------------------------
#endif
