//---------------------------------------------------------------------------
#pragma hdrstop
#include "CRC.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// Constructor TCRC
__fastcall TCRC::TCRC(LPWORD pCRC_Polynom)
{
        CRC_Polynom = *pCRC_Polynom;
        Create();
}
//---------------------------------------------------------------------------
// Destructor TCRC
__fastcall TCRC::~TCRC()
{
        Delete();
}
//---------------------------------------------------------------------------
// Innitialisation TCRC private
void __fastcall TCRC::Create()
{
        BYTE ind;
        WORD ind_Table, CRC, Value;
        pCRC_Table = new WORD[con_CRC_TABLE_LENGTH];
        for (ind_Table = 0; ind_Table < con_CRC_TABLE_LENGTH; ind_Table ++) {
            	CRC = 0;
                Value = ind_Table;
                for (ind = 0; ind < 8; ind ++) {
        	        if ((CRC ^ Value) & 0x0001) CRC = (CRC >> 1) ^ CRC_Polynom;
                        else CRC >>= 1;
                        Value >>= 1;
       	        }
      	        *(pCRC_Table + ind_Table) = CRC;
	}
}
//---------------------------------------------------------------------------
// Uninnitialisation TCRC private
void __fastcall TCRC::Delete()
{
        delete [] pCRC_Table;
}
//---------------------------------------------------------------------------
// Calculation CRC public
void __fastcall TCRC::Update(LPWORD pCRC, LPBYTE pBuffer, DWORD nBytes)
{
        WORD CRC = *pCRC;
        WORD Value;
        DWORD ind_Buffer;
        for (ind_Buffer = 0; ind_Buffer < nBytes; ind_Buffer ++) {
                Value = *(pBuffer + ind_Buffer);
                Value ^= CRC;
                Value &= 0x00FF;
                CRC = (CRC >> 8) ^ (*(pCRC_Table + Value));
        }
        *pCRC = CRC;
}
//---------------------------------------------------------------------------
